package com.bjlt.spider;

import feign.Request;
import org.springframework.boot.SpringApplication;
import org.springframework.boot.autoconfigure.SpringBootApplication;
import org.springframework.cloud.client.discovery.EnableDiscoveryClient;
import org.springframework.cloud.netflix.feign.EnableFeignClients;
import org.springframework.context.annotation.Bean;
import org.springframework.transaction.annotation.EnableTransactionManagement;

@EnableFeignClients
@EnableDiscoveryClient
@EnableTransactionManagement
@SpringBootApplication
public class ControlcenterApplication {

    public static void main(String[] args) {
        SpringApplication.run(ControlcenterApplication.class, args);


    }

    @Bean
    Request.Options feignOptions() {
        return new Request.Options(15 * 1000, 150 * 1000);
    }
}

