package com.bjlt.spider.chains.searchchaines;

import com.alibaba.fastjson.JSONObject;
import com.bjlt.spider.chains.abstractchains.AbstractHandler;
import com.bjlt.spider.entity.AirSourceLineVo;
import com.bjlt.spider.entity.SearchRequestAfterOta;
import com.bjlt.spider.util.RespEntity;
import lombok.extern.slf4j.Slf4j;
import org.springframework.stereotype.Component;

import java.sql.SQLException;
import java.util.List;

/**
 * @author: Scott
 * @Description: 把所有的航线黑名单过滤掉
 * @Date: Create in 10:26 2017/10/14
 */
@Component
@Slf4j
public class AirLineBlacklistControHandler extends AbstractHandler {


    @Override
    public RespEntity handleRequest(SearchRequestAfterOta vo) throws SQLException {
        //根据航线找到 是否在黑名单中
        log.info("---------黑名单控制开始---------");

        List<AirSourceLineVo> airSourceLines = vo.getAirSourceLines();


        AirSourceLineVo lineVo ;
        for (int i = 0; i <airSourceLines.size() ; i++) {
            Object o = airSourceLines.get(i);

            if (o instanceof String) {
                lineVo = JSONObject.parseObject(o.toString(), AirSourceLineVo.class);
            } else {
                lineVo = (AirSourceLineVo) o;
            }
            if (!lineVo.getStatus().equals(1)){
                airSourceLines.remove(i);
            }
        }
        log.info("---------黑名单控制完毕---------");
        vo.setAirSourceLines(airSourceLines);

        if (getNextHandler() != null) {
            return nextHandler.handleRequest(vo);
        }
        return RespEntity.success(vo);

    }
}
