package com.bjlt.spider.chains.searchchaines;

import com.bjlt.spider.chains.abstractchains.AbstractHandler;
import com.bjlt.spider.entity.AirSourceLineVo;
import com.bjlt.spider.entity.PlatformSourceVo;
import com.bjlt.spider.entity.SearchRequestAfterOta;
import com.bjlt.spider.search.service.PlatformSourceService;
import com.bjlt.spider.util.RespEntity;
import lombok.extern.slf4j.Slf4j;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Component;

import java.sql.SQLException;
import java.util.List;

/**
 * @author: Scott
 * @Description:
 * @Date: Create in 20:48 2017/10/16
 */
@Slf4j
@Component
public class PassengerCountHandler extends AbstractHandler {

    @Autowired
    private PlatformSourceService platformSourceService;


    @Override
    public RespEntity handleRequest(SearchRequestAfterOta ota) throws SQLException {

        log.info("---------乘客人数设置开始---------");

        List<AirSourceLineVo> airSourceLines = ota.getAirSourceLines();
        airSourceLines.forEach(t->{
            try {
                Integer passengerCount = new Integer(0);
                if (ota.getAdultNum() != null && ota.getChildNum() != null){
                    passengerCount = ota.getAdultNum() +  ota.getChildNum();
                }
                if (ota.getAdultNum() != null && ota.getChildNum() == null){
                    passengerCount = ota.getAdultNum() ;
                }
                if (ota.getAdultNum() == null && ota.getChildNum() != null){
                    passengerCount = ota.getChildNum() ;
                }
                if (ota.getAdultNum() == null && ota.getChildNum() == null){
                    passengerCount =  platformSourceService.listPlatformSourceVo(PlatformSourceVo.builder().sourceGroupId(t.getAirSourceID()).cid(ota.getCid()).build()).get(0).getPassengerCount();

                }

            t.setAdultNum(passengerCount);


            } catch (Exception e) {
                e.printStackTrace();
                log.info("---------乘客人数设置错误---------sc_platform_source");
            }
        });
        if (getNextHandler() != null) {
            return nextHandler.handleRequest(ota);
        }
        log.info("---------乘客人数设置完毕---------");
        return RespEntity.success(null);
    }
}
