package com.bjlt.spider.config;

import com.bjlt.spider.entity.AirSourceMenuVo;
import com.bjlt.spider.interfaces.ariasiaweb.AriasiaWebRpc;
import com.bjlt.spider.search.service.AirSourceMenuService;
import com.bjlt.spider.search.service.spiderservice.spiderserviceimpl.CreateSpiderServiceImpl;
import com.bjlt.spider.search.service.spiderservice.spiderserviceimpl.SpiderObservable;
import com.google.common.collect.Maps;
import lombok.extern.slf4j.Slf4j;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.boot.context.event.ApplicationReadyEvent;
import org.springframework.context.ApplicationListener;
import org.springframework.core.Ordered;
import org.springframework.stereotype.Component;

import java.sql.SQLException;
import java.util.List;
import java.util.Map;

/**
 * @author: Scott
 * @Description:
 * @Date: Create in 20:41 2017/10/16
 */
@Slf4j
@Component
public class HandlerInitListener implements ApplicationListener<ApplicationReadyEvent>, Ordered {

    @Autowired
    private AriasiaWebRpc ariasiaWebRpc;


    @Autowired
    private AirSourceMenuService menuService;

    @Autowired
    private CreateSpiderServiceImpl createSpiderService;

    @Autowired
    private SpiderObservable spiderObservable;



    public static Map<String,AriasiaWebRpc> searchMethodMap = Maps.newHashMap();

    public static Map verifyMethodMap = Maps.newHashMap();

    public static Map orderMethodMap = Maps.newHashMap();

    public static Map payMethodMap = Maps.newHashMap();





    @Override
    public void onApplicationEvent(ApplicationReadyEvent applicationReadyEvent) {
        try {
            List<AirSourceMenuVo> menuVos = menuService.listAirsourceMenu(AirSourceMenuVo.builder().isDefault(1).build());

            menuVos.forEach(s->{
                searchMethodMap.put(s.getGroupId(),ariasiaWebRpc);
                verifyMethodMap.put(s.getGroupId(),null);
                orderMethodMap.put(s.getGroupId(),null);
                payMethodMap.put(s.getGroupId(),null);
            });

            log.info("---------初始化 URL 信息---------");

            log.info("---------初始化被观察者和观察者---------");
            spiderObservable.addObserver(createSpiderService);


        } catch (SQLException e) {
            e.printStackTrace();
        }
    }


    @Override
    public int getOrder() {
        return Ordered.HIGHEST_PRECEDENCE;
    }
}
