package com.bjlt.spider.config;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.context.annotation.Bean;
import org.springframework.context.annotation.Configuration;
import org.springframework.data.redis.connection.RedisClusterConfiguration;
import org.springframework.data.redis.connection.RedisClusterConnection;
import org.springframework.data.redis.connection.RedisConnectionFactory;
import org.springframework.data.redis.connection.jedis.JedisConnectionFactory;
import org.springframework.data.redis.core.RedisTemplate;
import org.springframework.data.redis.core.StringRedisTemplate;

@Configuration
public class RedisClusterConfig {
    @Autowired
    private RedisClusterConfigProperties clusterProperties;

    @Bean
    public RedisConnectionFactory connectionFactory() {
         JedisConnectionFactory factory = new JedisConnectionFactory(new RedisClusterConfiguration(clusterProperties.getNodes()));
        /** 如果需要定制连接池,可以使用下面的方式进行配置 日后再说  */
//    private JedisPoolConfig pool = new JedisPoolConfig();
//    pool.setMaxIdle(8)
//    pool.setMaxTotal(8)
//    pool.set...
//    factory.setPoolConfig(pool)
        return factory;
    }

    @Bean
    @Autowired
    public RedisClusterConnection redisClusterConnection(RedisConnectionFactory connectionFactory) {
        return connectionFactory.getClusterConnection();
    }



    @Bean
    @Autowired
    public RedisTemplate RedisTemplate(RedisConnectionFactory connectionFactory) {
        return new StringRedisTemplate(connectionFactory);
    }


//    @Bean
//    @Autowired
//    public StringRedisTemplate stringRedisTemplate(RedisConnectionFactory connectionFactory) {
//        return new StringRedisTemplate(connectionFactory);
//    }

}
