package com.bjlt.spider.search.controller;

import com.bjlt.spider.chains.searchchaines.*;
import com.bjlt.spider.entity.SearchRequestAfterOta;
import com.bjlt.spider.search.service.spiderservice.CreateSpiderService;
import com.bjlt.spider.util.RespEntity;
import lombok.extern.slf4j.Slf4j;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.data.redis.core.RedisTemplate;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;

import java.sql.SQLException;

/**
 * @author: Scott
 * @Description:
 * @Date: Create in 11:46 2017/10/17
 */
@RestController
@RequestMapping(value = "/createSpider")
@Slf4j
public class CreatSpiderController {


    @Autowired
    private AirCodeExchangeHandler exchangeHandler;

    @Autowired
    private AirLineBlacklistControHandler blacklistControHandler;

    @Autowired
    private AirLineConfigHandler lineConfigHandler;

    @Autowired
    private AirSourceControHandler sourceControHandler;

    @Autowired
    private PlatformStatusControlHandler statusControlHandler;

    @Autowired
    private TimeControHandler timeControHandler;


    @Autowired
    private CreateSpiderService createSpiderService;

    @Autowired
    private PassengerCountHandler countHandler;


    public void initChain() {
        statusControlHandler.setNextHandler(timeControHandler);
        timeControHandler.setNextHandler(exchangeHandler);
        exchangeHandler.setNextHandler(lineConfigHandler);
        lineConfigHandler.setNextHandler(blacklistControHandler);
        blacklistControHandler.setNextHandler(sourceControHandler);
        sourceControHandler.setNextHandler(countHandler);
    }


    @PostMapping("create")
    public RespEntity createSpider(@RequestBody SearchRequestAfterOta otaConfig) throws SQLException, CloneNotSupportedException {
        initChain();
        RespEntity respEntity = statusControlHandler.handleRequest(otaConfig);

        //判断状态

        if (respEntity.getStatus() != 200) {
            return respEntity;
        }


        return createSpiderService.createSpider(otaConfig);
    }
}
