package com.bjlt.spider.search.dao.impl;

import com.bjlt.spider.entity.AirLineExchangeVo;
import com.bjlt.spider.search.dao.AirLineExchangeDao;
import lombok.extern.slf4j.Slf4j;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.dao.DataAccessException;
import org.springframework.jdbc.core.BeanPropertyRowMapper;
import org.springframework.jdbc.core.JdbcTemplate;
import org.springframework.jdbc.core.RowMapper;
import org.springframework.stereotype.Repository;

import java.sql.SQLException;
import java.util.HashMap;
import java.util.List;
import java.util.Map;
import java.util.stream.Collectors;

/**
 * @author: Scott
 * @Description:
 * @Date: Create in 15:42 2017/10/14
 */
@Slf4j
@Repository
public class AirLineExchangeDaoImpl implements AirLineExchangeDao {

    @Autowired
    private JdbcTemplate jdbcTemplate;


    @Override
    public List<AirLineExchangeVo> listAirLineExchangeVo(AirLineExchangeVo vo) throws SQLException {
        StringBuffer s = new StringBuffer();
        String select = "select id  , source_id as sourceId , city_code as cityCode, edit_user as editUser,plaine_code as airplaineCode, update_time as updateTime,add_time as addTime from sc_city_to_airplain ";
        s.append(select);
        Map<String, Object> m = map(vo);
        String where = "where 1=1 " + m.keySet().stream().map(t -> " and " + t + "=?").collect(Collectors.joining(" "));
        s.append(where);
        RowMapper<AirLineExchangeVo> rowMapper = new BeanPropertyRowMapper<>(AirLineExchangeVo.class);
        List<AirLineExchangeVo> list = null;
        try {
            list = jdbcTemplate.query(s.toString(), rowMapper, m.values().toArray());
        } catch (DataAccessException e) {
            log.error("数据库查询  AirLineExchangeVo Search BUG {}", e);
            throw new SQLException("MYSQL EROOR");
        }

        return list;
    }


    @Override
    public List<AirLineExchangeVo> listPageAirLineExchange(AirLineExchangeVo vo)throws SQLException {
        StringBuffer s=new StringBuffer();
        String select = "select id, source_id, city_code, plaine_code, edit_user, update_time, add_time from sc_city_to_airplain ";
        s.append(select );
        Map<String,Object> m=map(vo);
        String where = "where 1=1 " + m.keySet().stream().map(t -> " and " + t + "=?").collect(Collectors.joining(" "));
        vo.setTotal(count(where,m.values().toArray()));
        s.append(where);
        String limit = " limit " + vo.getStart() + "," + vo.getSize();
        s.append(limit);
        RowMapper<AirLineExchangeVo> rowMapper = new BeanPropertyRowMapper<AirLineExchangeVo>(AirLineExchangeVo.class);
        List<AirLineExchangeVo> list = jdbcTemplate.query(s.toString(), rowMapper,m.values().toArray());

        return list;
    }



    @Override
    public void insertSelective(AirLineExchangeVo vo) throws SQLException{
        StringBuffer s = new StringBuffer();
        s.append("insert into sc_city_to_airplain(");
        Map<String, Object> m = map(vo);
        s.append(String.join(",", m.keySet()));
        s.append(") values (");
        List<String> wenhao = m.keySet().stream().map(t -> "?").collect(Collectors.toList());
        s.append(String.join(",", wenhao));
        s.append(")");
        System.out.println(s.toString());
        jdbcTemplate.update(s.toString(), m.values().toArray());
    }

    @Override
    public void updateByPrimaryKeySelective(AirLineExchangeVo vo)throws SQLException {
        StringBuffer s = new StringBuffer();
        s.append("update sc_city_to_airplain set ");
        Map<String, Object> m = map(vo);
        String update = m.keySet().stream().map(t -> t + "=?").collect(Collectors.joining(","));
        s.append(update);
        System.out.println(update);
        s.append(" where 	id=" + vo.getId());
        jdbcTemplate.update(s.toString(), m.values().toArray());

    }

    @Override
    public void  deleteAirLineExchange(AirLineExchangeVo vo)throws SQLException{
        StringBuffer s=new StringBuffer();
        String select = "delete  from sc_city_to_airplain ";
        Map<String,Object> m=new HashMap();
        s.append(select);
        String where = "where 1=1 " + m.keySet().stream().map(t -> " and " + t + "=?").collect(Collectors.joining(" "));
        s.append(where);
        jdbcTemplate.update(s.toString(),m.values().toArray());

    }

    private static Map<String, Object> map(AirLineExchangeVo vo) {
        Map<String, Object> map = new HashMap();
        if (vo.getId() != null) {
            map.put("id", vo.getId());
        }

        if (vo.getSourceId() != null && !"".equals(vo.getSourceId())) {
            map.put("source_id", vo.getSourceId());
        }
        if (vo.getCityCode() != null && !"".equals(vo.getCityCode())) {
            map.put("city_code", vo.getCityCode());
        }
        if (vo.getAirplaineCode() != null && "".equals(vo.getAirplaineCode())) {
            map.put("plaine_code", vo.getAirplaineCode());
        }

        if (vo.getEditUser() != null && !"".equals(vo.getEditUser())) {
            map.put("edit_user", vo.getEditUser());
        }
        if (vo.getUpdateTime() != null && !"".equals(vo.getUpdateTime())) {
            map.put("update_time", vo.getUpdateTime());
        }
        if (vo.getAddTime() != null && !"".equals(vo.getAddTime())) {
            map.put("add_time", vo.getAddTime());
        }

        return map;

    }

    private Integer count(String where,Object[] objects)throws SQLException {
        String sql = "select count(*) from sc_city_to_airplain " + where;
        return jdbcTemplate.queryForObject(sql, Integer.class,objects);
    }

}
