package com.bjlt.spider.search.dao.impl;

import com.bjlt.spider.entity.AirSourceLineVo;
import com.bjlt.spider.search.dao.AirSourceLineDao;
import lombok.extern.slf4j.Slf4j;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.dao.DataAccessException;
import org.springframework.jdbc.core.BeanPropertyRowMapper;
import org.springframework.jdbc.core.JdbcTemplate;
import org.springframework.jdbc.core.RowMapper;
import org.springframework.stereotype.Repository;

import java.sql.SQLException;
import java.util.HashMap;
import java.util.List;
import java.util.Map;
import java.util.stream.Collectors;

/**
 * @author: Scott
 * @Description:
 * @Date: Create in 14:57 2017/10/16
 */
@Repository
@Slf4j
public class AirSourceLineDaoImpl implements AirSourceLineDao {
    @Autowired
    private JdbcTemplate jdbcTemplate;
    @Override
    public List<AirSourceLineVo> listAirSourceLine(AirSourceLineVo airSourceLineVo) throws SQLException {
        StringBuffer s = new StringBuffer();
        String select = "select air_source_id as airSourceID , from_city as fromCity , from_city_name as fromCityZh, to_city as toCity,  to_city_name as toCityZh, from_country as fromCountry ,edit_user as editUser, update_time as updateTime,add_time as addTime ,status from sc_airsource_line ";
        s.append(select);
        Map<String, Object> m = map(airSourceLineVo);
        String where = "where 1=1 " + m.keySet().stream().map(t -> " and " + t + "=?").collect(Collectors.joining(" "));
        s.append(where);
        RowMapper<AirSourceLineVo> rowMapper = new BeanPropertyRowMapper<>(AirSourceLineVo.class);
        List<AirSourceLineVo> list = null;
        try {
            list = jdbcTemplate.query(s.toString(), rowMapper, m.values().toArray());
        } catch (DataAccessException e) {
            log.error("数据库查询  AirSourceLineVo Search BUG {}", e);
            throw new SQLException("MYSQL EROOR");
        }

        return list;
    }

    @Override
    public List<AirSourceLineVo> listPageAirSourceLine(AirSourceLineVo vo) throws SQLException  {
        StringBuffer s=new StringBuffer();
        String select = "select id, air_source_id, from_city, from_city_name, to_city, to_city_name, from_country, edit_user, update_time, add_time, status from sc_airsource_line ";
        s.append(select );
        Map<String,Object> m=map(vo);
        String where = "where 1=1 " + m.keySet().stream().map(t -> " and " + t + "=?").collect(Collectors.joining(" "));
        vo.setTotal(count(where,m.values().toArray()));
        s.append(where);
        String limit = " limit " + vo.getStart() + "," + vo.getSize();
        s.append(limit);
        RowMapper<AirSourceLineVo> rowMapper = new BeanPropertyRowMapper<AirSourceLineVo>(AirSourceLineVo.class);
        List<AirSourceLineVo> list = jdbcTemplate.query(s.toString(), rowMapper,m.values().toArray());

        return list;
    }

    @Override
    public void insertSelective(AirSourceLineVo vo)throws SQLException  {
        StringBuffer s = new StringBuffer();
        s.append("insert into sc_airsource_line(");
        Map<String, Object> m = map(vo);
        s.append(String.join(",", m.keySet()));
        s.append(") values (");
        List<String> wenhao = m.keySet().stream().map(t -> "?").collect(Collectors.toList());
        s.append(String.join(",", wenhao));
        s.append(")");
        System.out.println(s.toString());
        jdbcTemplate.update(s.toString(), m.values().toArray());
    }

    @Override
    public void updateByPrimaryKeySelective(AirSourceLineVo vo) throws SQLException  {
        StringBuffer s = new StringBuffer();
        s.append("update sc_airsource_line set ");
        Map<String, Object> m = map(vo);
        String update = m.keySet().stream().map(t -> t + "=?").collect(Collectors.joining(","));
        s.append(update);
        System.out.println(update);
        s.append(" where 	id=" + vo.getId());
        jdbcTemplate.update(s.toString(), m.values().toArray());

    }





    @Override
    public void  deleteAirSourceLine(AirSourceLineVo vo)throws SQLException {
        StringBuffer s=new StringBuffer();
        String select = "delete  from sc_airsource_line ";
        Map<String,Object> m=new HashMap();
        s.append(select);
        String where = "where 1=1 " + m.keySet().stream().map(t -> " and " + t + "=?").collect(Collectors.joining(" "));
        s.append(where);
        jdbcTemplate.update(s.toString(),m.values().toArray());

    }


    private static Map<String, Object> map(AirSourceLineVo vo) {
        Map<String, Object> map = new HashMap();
        if (vo.getId() != null) {
            map.put("id", vo.getId());
        }
        if (vo.getAirSourceID() != null) {
            map.put("air_source_id", vo.getAirSourceID());
        }

        if (vo.getFromCity() != null && !"".equals(vo.getFromCity())) {
            map.put("from_city", vo.getFromCity());
        }
        if (vo.getToCity() != null && !"".equals(vo.getToCity())) {
            map.put("to_city", vo.getToCity());
        }
        if (vo.getFromCityZh() != null && "".equals(vo.getFromCityZh())) {
            map.put("from_city_name", vo.getFromCityZh());
        }
        if (vo.getToCityZh() != null && !"".equals(vo.getToCityZh())) {
            map.put("to_city_name", vo.getToCityZh());
        }
        if (vo.getFromCountry() != null && "".equals(vo.getFromCountry())) {
            map.put("from_country", vo.getFromCountry());
        }
        if (vo.getEditUser() != null && !"".equals(vo.getEditUser())) {
            map.put("edit_user", vo.getEditUser());
        }
        if (vo.getUpdateTime() != null && !"".equals(vo.getUpdateTime())) {
            map.put("update_time", vo.getUpdateTime());
        }
        if (vo.getAddTime() != null && !"".equals(vo.getAddTime())) {
            map.put("add_time", vo.getAddTime());
        }

        return map;

    }
    private Integer count(String where,Object[] objects) throws SQLException {
        String sql = "select count(*) from sc_airsource_line " + where;
        return jdbcTemplate.queryForObject(sql, Integer.class,objects);
    }
}
