package com.bjlt.spider.search.dao.impl;

import com.bjlt.spider.entity.AirSourceMenuVo;
import com.bjlt.spider.search.dao.AirsourceMenuDao;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.jdbc.core.BeanPropertyRowMapper;
import org.springframework.jdbc.core.JdbcTemplate;
import org.springframework.jdbc.core.RowMapper;
import org.springframework.stereotype.Repository;

import java.util.HashMap;
import java.util.List;
import java.util.Map;
import java.util.stream.Collectors;

@Repository
public class AirsourceMenuDaoImpl implements AirsourceMenuDao {

    @Autowired
    private JdbcTemplate jdbcTemplate;

    @Override
    public List<AirSourceMenuVo> listPageAirsourceMenu(AirSourceMenuVo vo) {
        StringBuffer s=new StringBuffer();
        String select = "select id, postfix, source_group, source_name, is_default, search_url,verify_url,order_url,pay_url, edit_user, update_time, add_time, status from sc_airsource_menu ";
        s.append(select );
        Map<String,Object> m=map(vo);
        String where = "where 1=1 " + m.keySet().stream().map(t -> " and " + t + "=?").collect(Collectors.joining(" "));
        vo.setTotal(count(where,m.values().toArray()));
        s.append(where);
        String limit = " limit " + vo.getStart() + "," + vo.getSize();
        s.append(limit);
        RowMapper<AirSourceMenuVo> rowMapper = new BeanPropertyRowMapper<AirSourceMenuVo>(AirSourceMenuVo.class);
        List<AirSourceMenuVo> list = jdbcTemplate.query(s.toString(), rowMapper,m.values().toArray());

        return list;
    }



    @Override
    public void insertSelective(AirSourceMenuVo vo) {
        StringBuffer s = new StringBuffer();
        s.append("insert into sc_airsource_menu(");
        Map<String, Object> m = map(vo);
        s.append(String.join(",", m.keySet()));
        s.append(") values (");
        List<String> wenhao = m.keySet().stream().map(t -> "?").collect(Collectors.toList());
        s.append(String.join(",", wenhao));
        s.append(")");
        System.out.println(s.toString());
        jdbcTemplate.update(s.toString(), m.values().toArray());
    }

    @Override
    public void updateByPrimaryKeySelective(AirSourceMenuVo vo) {
        StringBuffer s = new StringBuffer();
        s.append("update sc_airsource_menu set ");
        Map<String, Object> m = map(vo);
        String update = m.keySet().stream().map(t -> t + "=?").collect(Collectors.joining(","));
        s.append(update);
        System.out.println(update);
        s.append(" where 	id=" + vo.getId());
        jdbcTemplate.update(s.toString(), m.values().toArray());

    }



    @Override
    public List<AirSourceMenuVo> listAirsourceMenu(AirSourceMenuVo vo) {
        StringBuffer s=new StringBuffer();
        String select = "select id, postfix, group_id, source_name,source_group, is_default, search_url,verify_url,order_url,pay_url, passenger_count,edit_user, update_time, add_time, status from sc_airsource_menu ";
        s.append(select );
        Map<String,Object> m=map(vo);
        String where = "where 1=1 " + m.keySet().stream().map(t -> " and " + t + "=?").collect(Collectors.joining(" "));
        s.append(where);
        RowMapper<AirSourceMenuVo> rowMapper = new BeanPropertyRowMapper<AirSourceMenuVo>(AirSourceMenuVo.class);
        List<AirSourceMenuVo> list = jdbcTemplate.query(s.toString(), rowMapper,m.values().toArray());

        return list;
    }



    @Override
    public void  deleteAirsourceMenu(AirSourceMenuVo scAirsourceMenu){
        StringBuffer s=new StringBuffer();
        String select = "delete  from sc_airsource_menu ";
        Map<String,Object> m=new HashMap();
        s.append(select);
        String where = "where 1=1 " + m.keySet().stream().map(t -> " and " + t + "=?").collect(Collectors.joining(" "));
        s.append(where);
        jdbcTemplate.update(s.toString(),m.values().toArray());

    }
    private static Map<String,Object> map(AirSourceMenuVo vo) {
        Map<String,Object> map=new HashMap();
        if (vo.getId() != null) {
            map.put("id",vo.getId());
        }
        if (vo.getGroupId() != null && !vo.getGroupId().equals("")) {
            map.put("group_id",vo.getGroupId());
        }
        if (vo.getPostfix() != null && !vo.getPostfix().equals("")) {
            map.put("postfix",vo.getPostfix());
        }
        if (vo.getSourceGroup() != null && !vo.getSourceGroup().equals("")) {
            map.put("source_group",vo.getSourceGroup());
        }
        if (vo.getSourceName() != null && !vo.getSourceName().equals("")) {
            map.put("source_name",vo.getSourceName());
        }
        if (vo.getIsDefault() != null) {
            map.put("is_default",vo.getIsDefault());
        }
        if (vo.getSearchUrl() != null && !vo.getSearchUrl().equals("")) {
            map.put("search_url",vo.getSearchUrl());
        }
        if (vo.getVerufyUrl() != null && !vo.getVerufyUrl().equals("")) {
            map.put("verify_url",vo.getVerufyUrl());
        }
        if (vo.getOrderUrl() != null && !vo.getOrderUrl().equals("")) {
            map.put("order_url",vo.getOrderUrl());
        }
        if (vo.getPayUrl() != null && !vo.getPayUrl().equals("")) {
            map.put("pay_url",vo.getPayUrl());
        }
        if (vo.getEditUser() != null && !vo.getEditUser().equals("")) {
            map.put("edit_user",vo.getEditUser());
        }
        if (vo.getUpdateTime() != null && !vo.getUpdateTime().equals("")) {
            map.put("update_time",vo.getUpdateTime());
        }
        if (vo.getAddTime() != null && !vo.getAddTime().equals("")) {
            map.put("add_time",vo.getAddTime());
        }
        if (vo.getStatus() != null) {
            map.put("status",vo.getStatus());
        }

        return map;

    }
    private Integer count(String where,Object[] objects) {
        String sql = "select count(*) from sc_airsource_menu " + where;
        return jdbcTemplate.queryForObject(sql, Integer.class,objects);
    }

}
