package com.bjlt.spider.search.dao.impl;

import com.bjlt.spider.entity.PlatformMenuVo;
import com.bjlt.spider.search.dao.PlatformMenuDao;
import lombok.extern.slf4j.Slf4j;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.dao.DataAccessException;
import org.springframework.jdbc.core.BeanPropertyRowMapper;
import org.springframework.jdbc.core.JdbcTemplate;
import org.springframework.jdbc.core.RowMapper;
import org.springframework.stereotype.Repository;

import java.sql.SQLException;
import java.util.HashMap;
import java.util.List;
import java.util.Map;
import java.util.stream.Collectors;

/**
 * @author: Scott
 * @Description:
 * @Date: Create in 14:38 2017/10/13
 */
@Repository
@Slf4j
public class PlatformMenuDaoImpl implements PlatformMenuDao {

    @Autowired
    private JdbcTemplate jdbcTemplate;

    @Override
    public List<PlatformMenuVo> listPlatformMenu(PlatformMenuVo vo) throws SQLException {
        StringBuffer s = new StringBuffer();
        String select = "select id  , cid , status, platform_name as platformName, platform_name_zh as platformNameZh, edit_user as editUser, update_time as updateTime,add_time as addTime from sc_platform_menu ";
        s.append(select);
        Map<String, Object> m = map(vo);
        String where = "where 1=1 " + m.keySet().stream().map(t -> " and " + t + "=?").collect(Collectors.joining(" "));
        s.append(where);
        RowMapper<PlatformMenuVo> rowMapper = new BeanPropertyRowMapper<>(PlatformMenuVo.class);
        List<PlatformMenuVo> list = null;
        try {
            list = jdbcTemplate.query(s.toString(), rowMapper, m.values().toArray());
        } catch (DataAccessException e) {
            log.error("数据库查询  PlatformMenuVo Search BUG {}", e);
            throw new SQLException("MYSQL EROOR");
        }

        return list;
    }


    private static Map<String, Object> map(PlatformMenuVo vo) {
        Map<String, Object> map = new HashMap();
        if (vo.getId() != null) {
            map.put("id", vo.getId());
        }

        if (vo.getCid() != null && !"".equals(vo.getCid())) {
            map.put("cid", vo.getCid());
        }

        if (vo.getPlatformName() != null && !"".equals(vo.getPlatformName())) {
            map.put("platform_name", vo.getPlatformName());
        }
        if (vo.getPlatformNameZh() != null && !"".equals(vo.getPlatformNameZh())) {
            map.put("platform_name_zh", vo.getPlatformNameZh());
        }

        if (vo.getEditUser() != null && !"".equals(vo.getEditUser())) {
            map.put("edit_user", vo.getEditUser());
        }
        if (vo.getUpdateTime() != null && !"".equals(vo.getUpdateTime())) {
            map.put("update_time", vo.getUpdateTime());
        }
        if (vo.getAddTime() != null && !"".equals(vo.getAddTime())) {
            map.put("add_time", vo.getAddTime());
        }

        if (vo.getStatus() != null) {
            map.put("status", vo.getStatus());
        }

        return map;

    }


}
