package com.bjlt.spider.search.dao.impl;

import com.bjlt.spider.entity.PlatformSourceVo;
import com.bjlt.spider.search.dao.PlatformSourceDao;
import lombok.extern.slf4j.Slf4j;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.dao.DataAccessException;
import org.springframework.jdbc.core.BeanPropertyRowMapper;
import org.springframework.jdbc.core.JdbcTemplate;
import org.springframework.jdbc.core.RowMapper;
import org.springframework.stereotype.Repository;

import java.sql.SQLException;
import java.util.HashMap;
import java.util.List;
import java.util.Map;
import java.util.stream.Collectors;

/**
 * @author: Scott
 * @Description:
 * @Date: Create in 19:30 2017/10/16
 */
@Repository
@Slf4j
public class PlatformSourceDaoImpl implements PlatformSourceDao {

    @Autowired
    private JdbcTemplate jdbcTemplate;


    @Override
    public List<PlatformSourceVo> listPlatformSourceVo(PlatformSourceVo vo) throws SQLException {
        StringBuffer s = new StringBuffer();
        String select = "select id  , cid as cid , source_group_id as sourceGroupId,passenger_count, edit_user as editUser, update_time as updateTime,add_time as addTime,status from sc_platform_source ";
        s.append(select);
        Map<String, Object> m = map(vo);
        String where = "where 1=1 " + m.keySet().stream().map(t -> " and " + t + "=?").collect(Collectors.joining(" "));
        s.append(where);
        RowMapper<PlatformSourceVo> rowMapper = new BeanPropertyRowMapper<>(PlatformSourceVo.class);
        List<PlatformSourceVo> list = null;
        try {
            list = jdbcTemplate.query(s.toString(), rowMapper, m.values().toArray());
        } catch (DataAccessException e) {
            log.error("数据库查询  PlatformSourceVo Search BUG {}", e);
            throw new SQLException("MYSQL EROOR");
        }

        return list;
    }


    private static Map<String, Object> map(PlatformSourceVo vo) {
        Map<String, Object> map = new HashMap();
        if (vo.getId() != null) {
            map.put("id", vo.getId());
        }

        if (vo.getCid() != null) {
            map.put("cid", vo.getCid());
        }

        if (vo.getSourceGroupId() != null) {
            map.put("source_group_id", vo.getSourceGroupId());
        }
        if (vo.getStatus() != null) {
            map.put("status", vo.getStatus());
        }


        if (vo.getPassengerCount() != null) {
            map.put("passenger_count", vo.getStatus());
        }
        if (vo.getEditUser() != null && !"".equals(vo.getEditUser())) {
            map.put("edit_user", vo.getEditUser());
        }
        if (vo.getUpdateTime() != null && !"".equals(vo.getUpdateTime())) {
            map.put("update_time", vo.getUpdateTime());
        }
        if (vo.getAddTime() != null && !"".equals(vo.getAddTime())) {
            map.put("add_time", vo.getAddTime());
        }
        return map;

    }

}
