package com.bjlt.spider.search.dao.impl;

import com.bjlt.spider.entity.RefundRules;
import com.bjlt.spider.search.dao.RefundRulesDao;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.jdbc.core.BeanPropertyRowMapper;
import org.springframework.jdbc.core.JdbcTemplate;
import org.springframework.jdbc.core.RowMapper;
import org.springframework.stereotype.Repository;

import java.util.HashMap;
import java.util.List;
import java.util.Map;
import java.util.stream.Collectors;
/**
* sc_refund_rules
*/
@Repository
public class RefundRulesDaoImpl implements RefundRulesDao {
	@Autowired
	private JdbcTemplate jdbcTemplate;

	@Override
	public List<RefundRules> listPageRefundRules(RefundRules RefundRules) {
		StringBuffer s = new StringBuffer();
		String select = "select id, source_group_id, has_refund, refund, part_refund, part_refund_price, has_endorse, endorse, part_endorse, part_endorse_price, endorsement, has_baggage, baggage, has_no_show, no_show_limit_time, penalty, special_no_show, other, edit_user, add_time, update_time from sc_refund_rules ";
		s.append(select);
		Map<String, Object> m = map(RefundRules);
		String where = "where 1=1 " + m.keySet().stream().map(t -> " and " + t + "=?").collect(Collectors.joining(" "));
		RefundRules.setTotal(count(where, m.values().toArray()));
		s.append(where);
		String limit = " limit " + RefundRules.getStart() + "," + RefundRules.getSize();
		s.append(limit);
		RowMapper<RefundRules> rowMapper = new BeanPropertyRowMapper<RefundRules>(RefundRules.class);
		List<RefundRules> list = jdbcTemplate.query(s.toString(), rowMapper, m.values().toArray());

		return list;
	}


	@Override
	public void insertSelective(RefundRules RefundRules) {
		StringBuffer s = new StringBuffer();
		s.append("insert into sc_refund_rules(");
		Map<String, Object> m = map(RefundRules);
		s.append(String.join(",", m.keySet()));
		s.append(") values (");
		List<String> wenhao = m.keySet().stream().map(t -> "?").collect(Collectors.toList());
		s.append(String.join(",", wenhao));
		s.append(")");
		System.out.println(s.toString());
		jdbcTemplate.update(s.toString(), m.values().toArray());
	}

	@Override
	public void updateByPrimaryKeySelective(RefundRules RefundRules) {
		StringBuffer s = new StringBuffer();
		s.append("update sc_refund_rules set ");
		Map<String, Object> m = map(RefundRules);
		String update = m.keySet().stream().map(t -> t + "=?").collect(Collectors.joining(","));
		s.append(update);
		System.out.println(update);
		s.append(" where 	id=" + RefundRules.getId());
		jdbcTemplate.update(s.toString(), m.values().toArray());

	}


	@Override
	public List<RefundRules> listRefundRules(RefundRules RefundRules) {
		StringBuffer s = new StringBuffer();
		String select = "select id, source_group_id, has_refund, refund, part_refund, part_refund_price, has_endorse, endorse, part_endorse, part_endorse_price, endorsement, has_baggage, baggage, has_no_show, no_show_limit_time, penalty, special_no_show, other, edit_user, add_time, update_time from sc_refund_rules ";
		s.append(select);
		Map<String, Object> m = map(RefundRules);
		String where = "where 1=1 " + m.keySet().stream().map(t -> " and " + t + "=?").collect(Collectors.joining(" "));
		s.append(where);
		RowMapper<RefundRules> rowMapper = new BeanPropertyRowMapper<RefundRules>(RefundRules.class);
		List<RefundRules> list = jdbcTemplate.query(s.toString(), rowMapper, m.values().toArray());

		return list;
	}
	@Override
	public void deleteRefundRules(RefundRules RefundRules) {
		StringBuffer s = new StringBuffer();
		String select = "delete  from sc_refund_rules ";
		Map<String, Object> m = new HashMap();
		s.append(select);
		String where = "where 1=1 " + m.keySet().stream().map(t -> " and " + t + "=?").collect(Collectors.joining(" "));
		s.append(where);
		jdbcTemplate.update(s.toString(), m.values().toArray());

	}

	private static Map<String, Object> map(RefundRules RefundRules) {
		Map<String, Object> map = new HashMap();
		if (RefundRules.getId() != null) {
			map.put("id", RefundRules.getId());
		}
		if (RefundRules.getSourceGroupId() != null) {
			map.put("source_group_id", RefundRules.getSourceGroupId());
		}
		if (RefundRules.getHasRefund() != null) {
			map.put("has_refund", RefundRules.getHasRefund());
		}
		if (RefundRules.getRefund() != null && !RefundRules.getRefund().equals("")) {
			map.put("refund", RefundRules.getRefund());
		}
		if (RefundRules.getPartRefund() != null) {
			map.put("part_refund", RefundRules.getPartRefund());
		}
		if (RefundRules.getPartRefundPrice() != null && !RefundRules.getPartRefundPrice().equals("")) {
			map.put("part_refund_price", RefundRules.getPartRefundPrice());
		}
		if (RefundRules.getHasEndorse() != null) {
			map.put("has_endorse", RefundRules.getHasEndorse());
		}
		if (RefundRules.getEndorse() != null && !RefundRules.getEndorse().equals("")) {
			map.put("endorse", RefundRules.getEndorse());
		}
		if (RefundRules.getPartEndorse() != null) {
			map.put("part_endorse", RefundRules.getPartEndorse());
		}
		if (RefundRules.getPartEndorsePrice() != null) {
			map.put("part_endorse_price", RefundRules.getPartEndorsePrice());
		}
		if (RefundRules.getEndorsement() != null) {
			map.put("endorsement", RefundRules.getEndorsement());
		}
		if (RefundRules.getHasBaggage() != null) {
			map.put("has_baggage", RefundRules.getHasBaggage());
		}
		if (RefundRules.getBaggage() != null && !RefundRules.getBaggage().equals("")) {
			map.put("baggage", RefundRules.getBaggage());
		}
		if (RefundRules.getHasNoShow() != null) {
			map.put("has_no_show", RefundRules.getHasNoShow());
		}
		if (RefundRules.getNoShowLimitTime() != null) {
			map.put("no_show_limit_time", RefundRules.getNoShowLimitTime());
		}
		if (RefundRules.getPenalty() != null) {
			map.put("penalty", RefundRules.getPenalty());
		}
		if (RefundRules.getSpecialNoShow() != null) {
			map.put("special_no_show", RefundRules.getSpecialNoShow());
		}
		if (RefundRules.getOther() != null && !RefundRules.getOther().equals("")) {
			map.put("other", RefundRules.getOther());
		}
		if (RefundRules.getEditUser() != null && !RefundRules.getEditUser().equals("")) {
			map.put("edit_user", RefundRules.getEditUser());
		}
		if (RefundRules.getAddTime() != null && !RefundRules.getAddTime().equals("")) {
			map.put("add_time", RefundRules.getAddTime());
		}
		if (RefundRules.getUpdateTime() != null && !RefundRules.getUpdateTime().equals("")) {
			map.put("update_time", RefundRules.getUpdateTime());
		}

		return map;

	}

	private Integer count(String where, Object[] objects) {
		String sql = "select count(*) from sc_refund_rules " + where;
		return jdbcTemplate.queryForObject(sql, Integer.class, objects);
	}


}
