package com.bjlt.spider.search.dao.impl;

import com.bjlt.spider.entity.TimeControConfigVo;
import com.bjlt.spider.search.dao.TimeControConfigDao;
import lombok.extern.slf4j.Slf4j;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.dao.DataAccessException;
import org.springframework.jdbc.core.BeanPropertyRowMapper;
import org.springframework.jdbc.core.JdbcTemplate;
import org.springframework.jdbc.core.RowMapper;
import org.springframework.stereotype.Repository;

import java.sql.SQLException;
import java.util.HashMap;
import java.util.List;
import java.util.Map;
import java.util.stream.Collectors;

/**
 * @author: Scott
 * @Description:
 * @Date: Create in 11:39 2017/10/13
 */
@Repository
@Slf4j
public class TimeControConfigDaoImpl implements TimeControConfigDao {


    @Autowired
    private JdbcTemplate jdbcTemplate;

    @Override
    public List<TimeControConfigVo> listTimeControConfig(TimeControConfigVo vo) throws SQLException {
        StringBuffer s = new StringBuffer();
        String select = "select timecontro_id as timecontroId , platform_id as platFormId , saledate_start as saleDateStart, saledate_end as saleDateEnd , daytime_start as dayTimeStart , daytime_end as dayTimeEnd , edit_user as editUser, update_time as updateTime,add_time as addTime from sc_service_time_contro ";
        s.append(select);
        Map<String, Object> m = map(vo);
        String where = "where 1=1 " + m.keySet().stream().map(t -> " and " + t + "=?").collect(Collectors.joining(" "));
        s.append(where);
        RowMapper<TimeControConfigVo> rowMapper = new BeanPropertyRowMapper<TimeControConfigVo>(TimeControConfigVo.class);
        List<TimeControConfigVo> list = null;
        try {
            list = jdbcTemplate.query(s.toString(), rowMapper, m.values().toArray());
        } catch (DataAccessException e) {
            log.error("数据库查询  TimeControConfig Search BUG {}",e);
            throw new SQLException("MYSQL EROOR");
        }

        return list;
    }

    private static Map<String, Object> map(TimeControConfigVo vo) {
        Map<String, Object> map = new HashMap();
        if (vo.getTimecontroId() != null) {
            map.put("timecontro_id", vo.getTimecontroId());
        }
        if (vo.getPlatFormId() != null) {
            map.put("platform_id", vo.getPlatFormId());
        }
        if (vo.getSaleDateStart() != null && !"".equals(vo.getSaleDateStart())) {
            map.put("saledate_start", vo.getSaleDateStart());
        }
        if (vo.getSaleDateEnd() != null && !"".equals(vo.getSaleDateEnd())) {
            map.put("saledate_end", vo.getSaleDateEnd());
        }
        if (vo.getDayTimeStart() != null && !"".equals(vo.getDayTimeStart())) {
            map.put("daytime_start", vo.getDayTimeStart());
        }
        if (vo.getDayTimeEnd() != null && !"".equals(vo.getDayTimeEnd())) {
            map.put("daytime_end", vo.getDayTimeEnd());
        }
        if (vo.getEditUser() != null && !"".equals(vo.getEditUser())) {
            map.put("edit_user", vo.getEditUser());
        }
        if (vo.getUpdateTime() != null && !"".equals(vo.getUpdateTime())) {
            map.put("update_time", vo.getUpdateTime());
        }
        if (vo.getAddTime() != null && !"".equals(vo.getAddTime())) {
            map.put("add_time", vo.getAddTime());
        }



        return map;

    }
}
