package com.bjlt.spider.search.dao.impl;

import com.bjlt.spider.entity.UnKnownLineVo;
import com.bjlt.spider.search.dao.UnknownLineDao;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.jdbc.core.BeanPropertyRowMapper;
import org.springframework.jdbc.core.JdbcTemplate;
import org.springframework.jdbc.core.RowMapper;
import org.springframework.stereotype.Repository;

import java.sql.SQLException;
import java.util.HashMap;
import java.util.List;
import java.util.Map;
import java.util.stream.Collectors;

/**
 * @author: Scott
 * @Description:
 * @Date: Create in 14:39 2017/10/16
 */
@Repository
public class UnknownLineDaoImpl implements UnknownLineDao {


    @Autowired
    private JdbcTemplate jdbcTemplate;


    @Override
    public void insertSelective(UnKnownLineVo unKnownLineVo) {
        StringBuffer s = new StringBuffer();
        s.append("insert into sc_unbook_line(");
        Map<String, Object> m = map(unKnownLineVo);
        s.append(String.join(",", m.keySet()));
        s.append(") values (");
        List<String> wenhao = m.keySet().stream().map(t -> "?").collect(Collectors.toList());

        s.append(String.join(",", wenhao));
        s.append(")");
        System.out.println(s.toString());
        jdbcTemplate.update(s.toString(), m.values().toArray());
    }


    private static Map<String, Object> map(UnKnownLineVo vo) {
        Map<String, Object> map = new HashMap();
        if (vo.getId() != null) {
            map.put("id", vo.getId());
        }

        if (vo.getFromCity() != null && !"".equals(vo.getFromCity())) {
            map.put("from_city", vo.getFromCity());
        }
        if (vo.getToCity() != null && !"".equals(vo.getToCity())) {
            map.put("to_city", vo.getToCity());
        }
        return map;
    }

    @Override
    public void updateByPrimaryKeySelective(UnKnownLineVo vo) throws SQLException {
        StringBuffer s = new StringBuffer();
        s.append("update sc_unbook_line set ");
        Map<String, Object> m = map(vo);
        String update = m.keySet().stream().map(t -> t + "=?").collect(Collectors.joining(","));
        s.append(update);
        System.out.println(update);
        s.append(" where 	id=" + vo.getId());
        jdbcTemplate.update(s.toString(), m.values().toArray());
    }

    @Override
    public List<UnKnownLineVo> listUnKnownLine(UnKnownLineVo vo) throws SQLException {
        StringBuffer s=new StringBuffer();
        String select = "select id, from_city, to_city, add_time from sc_unbook_line ";
        s.append(select );
        Map<String,Object> m=map(vo);
        String where = "where 1=1 " + m.keySet().stream().map(t -> " and " + t + "=?").collect(Collectors.joining(" "));
        s.append(where);
        RowMapper<UnKnownLineVo> rowMapper = new BeanPropertyRowMapper<UnKnownLineVo>(UnKnownLineVo.class);
        List<UnKnownLineVo> list = jdbcTemplate.query(s.toString(), rowMapper,m.values().toArray());

        return list;
    }

    @Override
    public void deleteUnKnownLine(UnKnownLineVo vo) throws SQLException {
        StringBuffer s=new StringBuffer();
        String select = "delete  from sc_unbook_line ";
        Map<String,Object> m=new HashMap();
        s.append(select);
        String where = "where 1=1 " + m.keySet().stream().map(t -> " and " + t + "=?").collect(Collectors.joining(" "));
        s.append(where);
        jdbcTemplate.update(s.toString(),m.values().toArray());
    }

    @Override
    public List<UnKnownLineVo> listPageUnKnownLine(UnKnownLineVo vo) throws SQLException {
        StringBuffer s=new StringBuffer();
        String select = "select id, from_city, to_city, add_time from sc_unbook_line ";
        s.append(select );
        Map<String,Object> m=map(vo);
        String where = "where 1=1 " + m.keySet().stream().map(t -> " and " + t + "=?").collect(Collectors.joining(" "));
        vo.setTotal(count(where,m.values().toArray()));
        s.append(where);
        String limit = " limit " + vo.getStart() + "," + vo.getSize();
        s.append(limit);
        RowMapper<UnKnownLineVo> rowMapper = new BeanPropertyRowMapper<UnKnownLineVo>(UnKnownLineVo.class);
        List<UnKnownLineVo> list = jdbcTemplate.query(s.toString(), rowMapper,m.values().toArray());

        return list;
    }
    private Integer count(String where,Object[] objects) throws SQLException{
        String sql = "select count(*) from sc_unbook_line " + where;
        return jdbcTemplate.queryForObject(sql, Integer.class,objects);
    }
}
