package com.bjlt.spider.utils;

import com.google.common.util.concurrent.ThreadFactoryBuilder;

import java.util.ArrayList;
import java.util.List;
import java.util.concurrent.*;
import java.util.concurrent.atomic.AtomicInteger;

/**
 * @author: Scott
 * @Description:
 * @Date: Create in 14:44 2017/10/19
 */
public class ReflectUtils {
    public static void main(String[] args) {

        ThreadFactory factory = new ThreadFactoryBuilder()
                .setNameFormat("test-pool-%d").build();
        ExecutorService executorService =
                new ThreadPoolExecutor(8, 400, 30L, TimeUnit.SECONDS,
                        new LinkedBlockingDeque<>(1024), factory, new ThreadPoolExecutor.DiscardPolicy());
        AtomicInteger atomicInteger = new AtomicInteger(0);

        List<Integer> taskList = new ArrayList();
        List<Integer> retList = new ArrayList();
        taskList.add(5);
        //taskList.add(8);
        taskList.add(7);
        taskList.add(6);

        System.out.println("运行 CPU 核数" + Runtime.getRuntime().availableProcessors());

//        taskList.forEach(t ->
//                defaultDragons.add(new FutureTask<>(new TestHandler(t)))
//        );
        Long start = System.currentTimeMillis();


//        Integer respEntity = null;
//        try {
//            respEntity = future.get(10, TimeUnit.SECONDS);
//
//        } catch (Exception e) {
//            e.printStackTrace();
//        }
//        return respEntity;


        taskList.parallelStream().forEach(t -> {
            final CompletableFuture<Integer> future =
                    CompletableFuture.supplyAsync(() -> new TestHandler(t).call(),executorService);
            try {
                Integer integer = null;
                try {
                    integer = future.get(10, TimeUnit.SECONDS);
                    System.out.println("十秒之前 拿到数据 " + integer);
                    retList.add(integer);
                    if (retList.size() == taskList.size()){
                        System.out.println("拿到了全部的数据，开始做下一步的事情 ");
                    }
                } catch (TimeoutException e) {
                    int i = atomicInteger.incrementAndGet();
                    if (i ==1){
                        System.out.println("将得到的数据打包带走");
                    }
                    System.out.println("10秒钟的时候没有获取到数据， "+"此时结果集合里面共有数据 " + retList.size() + "条");
                    System.out.println("程序已经运行了"+(System.currentTimeMillis()-start)/1000+"秒");
                    try {
                       Integer f =  future.get(20,TimeUnit.SECONDS);

                       if (f != null){
                           System.out.println("将"+f+"缓存");
                       }

                    } catch (TimeoutException e1) {
                        e1.printStackTrace();

                    }

                }
            } catch (InterruptedException e) {
                e.printStackTrace();
            } catch (ExecutionException e) {
                e.printStackTrace();
            }

        });
        long end = System.currentTimeMillis();

        System.out.println("运行时间为：" + (end-start)/1000);
        System.out.println("结果容量是 " + retList.size());


//                    executorService.execute(t);
//
//
//                    try {
//                        t.get(10,TimeUnit.SECONDS);
//                    } catch (InterruptedException e) {
//                        e.printStackTrace();
//                    } catch (ExecutionException e) {
//                        e.printStackTrace();
//                    } catch (TimeoutException e) {
//                        //e.printStackTrace();
//                        System.out.println("10秒了还没有获得数据，继续往后延迟");
//
//                    }
//
//                }


//            try {
//                Object o = null;
//                try {
//                    o = t.get(10, TimeUnit.SECONDS);
//
//                    if (o != null){
//                        System.out.println("已经获得"+o);
//                    }
//                    retList.add((Integer) o);
//                } catch (TimeoutException e) {
//
//                    try {
//                        System.out.println("超过10秒 继续运行 将结果放入缓存");
//                        Object r = t.get(15, TimeUnit.SECONDS);
//                        System.out.println("缓存结果"+r);
//
//
//                    } catch (TimeoutException e1) {
//                        e1.printStackTrace();
//                    }
//                }
//            } catch (InterruptedException e) {
//                e.printStackTrace();
//            } catch (ExecutionException e) {
//                e.printStackTrace();
//            }
//
//        });


    }

}
