package com.bjlt.spider.utils;

import com.google.common.util.concurrent.ThreadFactoryBuilder;

import java.util.ArrayList;
import java.util.concurrent.*;

/**
 * @author: Scott
 * @Description:
 * @Date: Create in 13:06 2017/10/21
 */
public class ThreadTest {
    static ThreadFactory factory = new ThreadFactoryBuilder()
            .setNameFormat("search-pool-%d").build();

    private static ExecutorService executorService =
            new ThreadPoolExecutor(30, 400, 30L, TimeUnit.SECONDS,
                    new LinkedBlockingDeque<>(1024), factory, new ThreadPoolExecutor.DiscardPolicy());

    private final static CountDownLatch mCountDownLatch = new CountDownLatch(3);

    public static void main(String[] args) {

        ArrayList<FutureTask> list = new ArrayList();


        FutureTask<String> future1 = new FutureTask<>(new RunnableTest("10s"));
        FutureTask<String> future2 = new FutureTask<>(new RunnableTest("20s"));

        FutureTask<String> future3 = new FutureTask<>(new RunnableTest("30s"));

        list.add(future1);
        list.add(future2);
        list.add(future3);




        list.parallelStream().forEach(t->{
            executorService.submit(t);
            try {

                System.out.println(t.get(12,TimeUnit.SECONDS));
                mCountDownLatch.countDown();
            } catch (InterruptedException e) {
                e.printStackTrace();
            } catch (ExecutionException e) {
                e.printStackTrace();
            } catch (TimeoutException e) {
                e.printStackTrace();
            }finally {
            }

        });


//        CompletableFuture future = CompletableFuture.supplyAsync(()->getString());
//
//        System.out.println("我在执行这里");
//        try {
//            System.out.println(future.get());
//        } catch (InterruptedException e) {
//            e.printStackTrace();
//        } catch (ExecutionException e) {
//            e.printStackTrace();
//        }
    }

}
